#!/usr/bin/perl
# vp 16.11.2021 09:20:20

# $ARGV[0]||='test1.bas';

die <<HELP unless @ARGV;
Aufruf: basic2jtc text-file
konvertiert Basic/DEBUG-Textdateien ins jtc-Format
HELP

open IN, "<$ARGV[0]" or die "$ARGV[0] not found\n";
($file = "$ARGV[0]") =~ s/\..*//;
$file = substr($file,0,8);

# Ausgabe als JTC-File
$OUT = "${file}.jtc";
print "$OUT\n";
open OUT, ">$OUT";
binmode OUT;

$aadr=0x8800;

#JTC/KC-Header
print OUT pack("
	A8		   # dateiname: array[0..7] of char;
	A3		   # dateityp: array[0..2] of char;
	xx		   # e1, e2: byte;
	xxxc		   # psum, arb, blnr, lblnr: byte;
	sss		   # aadr, eadr, sadr: word;
	x		   # sby: byte;
	", $file, '', 3, $aadr, 0, 0
);
print OUT "\x00"x(128-24);  # 1. Block fr MC mit 00 auffllen



# Einlesen
@basic=();
while (<IN>) {
	chomp;
	($line, $code) = /^\s*(\d+)\s*(.*)/;
	if ($line eq '' or $code eq '') {
		print "keine BASIC-Zeile '$_'\n";
	} else {
		print OUT pack('nA*', $line, $code), "\0";	# n unsigned 16-bit in big-endian order
	}
}
close IN;

print OUT "\xFF\xFF";
close OUT;

